#!/bin/sh
fullupd=0
echo "Perform full ERASE and Update (Y/N)?" > /dev/carddsp
/usr/sbin/diag/waitkey
if [ $? -eq 89 ] ; then
	fullupd=1
fi
echo "\`" > /dev/carddsp
if [ $fullupd -eq 1 ] ; then
	echo "Clearing NAND\\r" > /dev/carddsp
	mtd_debug erase /dev/mtd1 0x00000000 0x04000000
	mount -t jffs2 /dev/mtdblock1 /mnt/nand
	rm -r /mnt/nand/*
	echo "Creating directories\\r" > /dev/carddsp
	mkdir /mnt/nand/apps
	mkdir /mnt/nand/bin
	mkdir /mnt/nand/cfg
	mkdir /mnt/nand/fonts
	mkdir /mnt/nand/images
	mkdir /mnt/nand/indicator
	mkdir /mnt/nand/www
	mkdir /mnt/nand/tkt
else
	echo "\`" > /dev/carddsp
	echo "Mounting NAND\\r" > /dev/carddsp
	mount -t jffs2 /dev/mtdblock1 /mnt/nand
fi
cpysysfiles=1
if [ $fullupd -ne 1 ] ; then
	echo "\`" > /dev/carddsp
	echo "Update system programs (Y/N)?" > /dev/carddsp
	/usr/sbin/diag/waitkey
	if [ $? -ne 89 ] ; then
		cpysysfiles=0
	fi
	echo "\`" > /dev/carddsp
fi
if [ $cpysysfiles -eq 1 ] ; then
	echo "Copying bin\\r" > /dev/carddsp
	cp -p ./nand/bin/appmenu /mnt/nand/bin/appmenu
	cp -p ./nand/bin/appmenu.sh /mnt/nand/bin/appmenu.sh
	cp -p ./nand/bin/cardbas /mnt/nand/bin/cardbas
	cp -p ./nand/bin/filemanage /mnt/nand/bin/filemanage
	cp -p ./nand/bin/filemgr.sh /mnt/nand/bin/filemgr.sh
	cp -p ./nand/bin/imageview /mnt/nand/bin/imageview
	cp -p ./nand/bin/loadsrec /mnt/nand/bin/loadsrec
	cp -p ./nand/bin/touchcal /mnt/nand/bin/touchcal
	cp -p ./nand/bin/transfer /mnt/nand/bin/transfer
	cp -p ./nand/bin/transfer.sh /mnt/nand/bin/transfer.sh
	cp -p ./nand/bin/wtsvr /mnt/nand/bin/wtsvr
	chmod +x /mnt/nand/bin/*
	echo "Copying indicator\\r" > /dev/carddsp
	cp -p ./nand/indicator/* /mnt/nand/indicator
fi
cpycfgfiles=1
if [ $fullupd -ne 1 ] ; then
	echo "\`" > /dev/carddsp
	echo "Update config files (Y/N)?" > /dev/carddsp
	/usr/sbin/diag/waitkey
	if [ $? -ne 89 ] ; then
		cpycfgfiles=0
	fi
	echo "\`" > /dev/carddsp
fi
if [ $cpycfgfiles -eq 1 ] ; then
	echo "Copying cfg\\r" > /dev/carddsp
	cp -p ./nand/cfg/* /mnt/nand/cfg
fi
cpyfontfiles=1
if [ $fullupd -ne 1 ] ; then
	echo "\`" > /dev/carddsp
	echo "Update font files (Y/N)?" > /dev/carddsp
	/usr/sbin/diag/waitkey
	if [ $? -ne 89 ] ; then
		cpyfontfiles=0
	fi
	echo "\`" > /dev/carddsp
fi
if [ $cpyfontfiles -eq 1 ] ; then
	echo "Copying fonts\\r" > /dev/carddsp
	cp -p ./nand/fonts/* /mnt/nand/fonts
fi
cpyimgfiles=1
if [ $fullupd -ne 1 ] ; then
	echo "\`" > /dev/carddsp
	echo "Update image files (Y/N)?" > /dev/carddsp
	/usr/sbin/diag/waitkey
	if [ $? -ne 89 ] ; then
		cpyimgfiles=0
	fi
	echo "\`" > /dev/carddsp
fi
if [ $cpyimgfiles -eq 1 ] ; then
	echo "Copying images\\r" > /dev/carddsp
	cp -p ./nand/images/* /mnt/nand/images
fi
cpywwwfiles=1
if [ $fullupd -ne 1 ] ; then
	echo "\`" > /dev/carddsp
	echo "Update web server files (Y/N)?" > /dev/carddsp
	/usr/sbin/diag/waitkey
	if [ $? -ne 89 ] ; then
		cpywwwfiles=0
	fi
	echo "\`" > /dev/carddsp
fi
if [ $cpywwwfiles -eq 1 ] ; then
	echo "Copying www\\r" > /dev/carddsp
	cp -r -p ./nand/www/* /mnt/nand/www
	echo "Creating www/html/fonts link" > /dev/carddsp
	ln -s /mnt/nand/fonts /mnt/nand/www/html/fonts
fi
cpyappfiles=1
if [ $fullupd -ne 1 ] ; then
	echo "\`" > /dev/carddsp
	echo "Update applications (Y/N)?" > /dev/carddsp
	/usr/sbin/diag/waitkey
	if [ $? -ne 89 ] ; then
		cpyappfiles=0
	fi
	echo "\`" > /dev/carddsp
fi
if [ $cpyappfiles -eq 1 ] ; then
	echo "Copying apps\\r" > /dev/carddsp
	cp -r -p ./nand/apps/* /mnt/nand/apps
	# In some cases upper case letters may get changed to lower - change them back
	mv /mnt/nand/apps/788ids /mnt/nand/apps/788IDS
	mv /mnt/nand/apps/788IDS/788ids.77x /mnt/nand/apps/788IDS/788IDS.77X

	chmod +x /mnt/nand/apps/ids/ids
	chmod +x /mnt/nand/apps/dfc/dfc
	chmod +x /mnt/nand/apps/chkwgh/chkwgh
	chmod +x /mnt/nand/apps/hway/hway
	chmod +x /mnt/nand/apps/mscale/mscale
	chmod +x /mnt/nand/apps/std/std
fi
if [ $fullupd -eq 1 ] ; then
	/usr/sbin/diag/loadsrec "./Demo1 M5213EVB Boot Loader.elf.S19" M W
	/usr/sbin/diag/loadsrec ./m5329evb_flash.S19 O W
	/usr/sbin/diag/loadsrec ./image.bin X W
else
	/usr/sbin/diag/loadsrec "./Demo1 M5213EVB Boot Loader.elf.S19" M
	/usr/sbin/diag/loadsrec ./m5329evb_flash.S19 O
	/usr/sbin/diag/loadsrec ./image.bin X
fi
echo "** Done ** - rebooting to complete" > /dev/carddsp
sleep 10
reboot

